org.apache.solr.client.solrj.cloud.autoscaling

## Class Suggester

- java.lang.Object
- - org.apache.solr.client.solrj.cloud.autoscaling.Suggester

Direct Known Subclasses:
  MoveReplicaSuggester, NoneSuggester

    public abstract class Suggester
    extends Object

### Nested Class Summary

Nested Classes
`static class` `Suggester.Hint`
`static class` `Suggester.SuggestionInfo`

### Field Summary

Fields
`protected EnumMap<Suggester.Hint,Object>` `hints`
`protected List<Violation>` `originalViolations`

### Constructor Summary

Constructors
Constructor and Description
`Suggester()`

### Method Summary

All Methods Instance Methods Concrete Methods
`Suggester` `forceOperation(boolean force)` Normally, only less loaded nodes are used for moving replicas.
`Policy.Session` `getSession()`
`SolrRequest` `getSuggestion()`
`Suggester` `hint(Suggester.Hint hint, Object value)`
`protected boolean` `isAllowed(Object v, Suggester.Hint hint)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### hints

    protected final EnumMap<Suggester.Hint,Object> hints

#### originalViolations

    protected List<Violation> originalViolations

### Constructor Detail

#### Suggester

    public Suggester()

### Method Detail

#### hint

    public Suggester hint(Suggester.Hint hint,
                          Object value)

#### forceOperation

    public Suggester forceOperation(boolean force)

Normally, only less loaded nodes are used for moving replicas. If this is a violation and a MOVE must be performed, set the flag to true.

#### getSuggestion

    public SolrRequest getSuggestion()

#### getSession

    public Policy.Session getSession()

#### isAllowed

    protected boolean isAllowed(Object v,
                                Suggester.Hint hint)